Index: /palm/trunk/SOURCE/exchange_horiz.f90
===================================================================
--- /palm/trunk/SOURCE/exchange_horiz.f90	(revision 1319)
+++ /palm/trunk/SOURCE/exchange_horiz.f90	(revision 1320)
@@ -1,5 +1,5 @@
  SUBROUTINE exchange_horiz( ar, nbgp_local)
 
-!--------------------------------------------------------------------------------!
+!------------------------------------------------------------------------------!
 ! This file is part of PALM.
 !
@@ -16,16 +16,19 @@
 !
 ! Copyright 1997-2014 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------!
+!------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements, 
+! kinds are defined in new module kinds, 
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
-!
-! 1318 2014-03-17 13:35:16Z raasch
-! module interfaces removed
 !
 ! 1257 2013-11-08 15:18:40Z raasch
@@ -45,35 +48,4 @@
 ! 841 2012-02-28 12:29:49Z maronga
 ! Excluded routine from compilation of namelist_file_check
-!
-! 709 2011-03-30 09:31:40Z raasch
-! formatting adjustments
-!
-! 707 2011-03-29 11:39:40Z raasch
-! grid_level directly used as index for MPI data type arrays,
-! bc_lr/ns replaced by bc_lr/ns_cyc
-!
-! 689 2011-02-20 19:31:12z gryschka 
-! Bugfix for some logical expressions 
-! (syntax was not compatible with all compilers)
-!
-! 683 2011-02-09 14:25:15Z raasch
-! optional synchronous exchange (sendrecv) implemented, code partly reformatted
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! Dynamic exchange of ghost points with nbgp_local to ensure that no useless 
-! ghost points exchanged in case of multigrid. type_yz(0) and type_xz(0)
-! used for normal grid, the remaining types used for the several grid levels.
-! Exchange is done via MPI-Vectors with a dynamic value of ghost points which
-! depend on the advection scheme. Exchange of left and right PEs is 10% faster 
-! with MPI-Vectors than without.
-!
-! 75 2007-03-22 09:54:05Z raasch
-! Special cases for additional gridpoints along x or y in case of non-cyclic
-! boundary conditions are not regarded any more
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.16  2006/02/23 12:19:08  raasch
-! anz_yz renamed ngp_yz
 !
 ! Revision 1.1  1997/07/24 11:13:29  raasch
@@ -87,7 +59,16 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE cpulog
-    USE indices
+    USE control_parameters,                                                    &
+        ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, mg_switch_to_pe0,             &
+               synchronous_exchange
+                
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+        
+    USE indices,                                                               &
+        ONLY:  nxl, nxr, nyn, nys, nzb, nzt
+        
+    USE kinds
+    
     USE pegrid
 
@@ -95,7 +76,12 @@
 
 
-    INTEGER ::  i, j, k, nbgp_local
-    REAL, DIMENSION(nzb:nzt+1,nys-nbgp_local:nyn+nbgp_local, &
-                    nxl-nbgp_local:nxr+nbgp_local) ::  ar
+    INTEGER(iwp) ::  i           !:
+    INTEGER(iwp) ::  j           !:
+    INTEGER(iwp) ::  k           !:
+    INTEGER(iwp) ::  nbgp_local  !:
+    
+    REAL(wp), DIMENSION(nzb:nzt+1,nys-nbgp_local:nyn+nbgp_local,               &
+                        nxl-nbgp_local:nxr+nbgp_local) ::  ar  !:
+                        
 
 #if ! defined( __check )
@@ -127,8 +113,8 @@
 !
 !--       Send right boundary, receive left one (synchronous)
-          CALL MPI_SENDRECV( ar(nzb,nys-nbgp_local,nxr+1-nbgp_local), 1, &
-                             type_yz(grid_level), pright, 1,             &
-                             ar(nzb,nys-nbgp_local,nxl-nbgp_local), 1,   &
-                             type_yz(grid_level), pleft,  1,             &
+          CALL MPI_SENDRECV( ar(nzb,nys-nbgp_local,nxr+1-nbgp_local), 1,       &
+                             type_yz(grid_level), pright, 1,                   &
+                             ar(nzb,nys-nbgp_local,nxl-nbgp_local), 1,         &
+                             type_yz(grid_level), pleft,  1,                   &
                              comm2d, status, ierr )
 
@@ -152,9 +138,9 @@
 !
 !--          Send right boundary, receive left one (asynchronous)
-             CALL MPI_ISEND( ar(nzb,nys-nbgp_local,nxr+1-nbgp_local), 1,          &
-                             type_yz(grid_level), pright, req_count+1, comm2d,    &
+             CALL MPI_ISEND( ar(nzb,nys-nbgp_local,nxr+1-nbgp_local), 1,       &
+                             type_yz(grid_level), pright, req_count+1, comm2d, &
                              req(req_count+3), ierr )
-             CALL MPI_IRECV( ar(nzb,nys-nbgp_local,nxl-nbgp_local),   1,          &
-                             type_yz(grid_level), pleft,  req_count+1, comm2d,    &
+             CALL MPI_IRECV( ar(nzb,nys-nbgp_local,nxl-nbgp_local),   1,       &
+                             type_yz(grid_level), pleft,  req_count+1, comm2d, &
                              req(req_count+4), ierr )
 
@@ -192,8 +178,8 @@
 !
 !--       Send rear boundary, receive front one (synchronous)
-          CALL MPI_SENDRECV( ar(nzb,nyn-nbgp_local+1,nxl-nbgp_local), 1, &
-                             type_xz(grid_level), pnorth, 1,             &
-                             ar(nzb,nys-nbgp_local,nxl-nbgp_local),   1, &
-                             type_xz(grid_level), psouth, 1,             &
+          CALL MPI_SENDRECV( ar(nzb,nyn-nbgp_local+1,nxl-nbgp_local), 1,       &
+                             type_xz(grid_level), pnorth, 1,                   &
+                             ar(nzb,nys-nbgp_local,nxl-nbgp_local),   1,       &
+                             type_xz(grid_level), psouth, 1,                   &
                              comm2d, status, ierr )
 
@@ -218,9 +204,9 @@
 !
 !--          Send rear boundary, receive front one (asynchronous)
-             CALL MPI_ISEND( ar(nzb,nyn-nbgp_local+1,nxl-nbgp_local), 1,          &
-                             type_xz(grid_level), pnorth, req_count+1, comm2d,    &
+             CALL MPI_ISEND( ar(nzb,nyn-nbgp_local+1,nxl-nbgp_local), 1,       &
+                             type_xz(grid_level), pnorth, req_count+1, comm2d, &
                              req(req_count+3), ierr )
-             CALL MPI_IRECV( ar(nzb,nys-nbgp_local,nxl-nbgp_local),   1,          &
-                             type_xz(grid_level), psouth, req_count+1, comm2d,    &
+             CALL MPI_IRECV( ar(nzb,nys-nbgp_local,nxl-nbgp_local),   1,       &
+                             type_xz(grid_level), psouth, req_count+1, comm2d, &
                              req(req_count+4), ierr )
 
Index: /palm/trunk/SOURCE/exchange_horiz_2d.f90
===================================================================
--- /palm/trunk/SOURCE/exchange_horiz_2d.f90	(revision 1319)
+++ /palm/trunk/SOURCE/exchange_horiz_2d.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements, 
+! kinds are defined in new module kinds, 
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -26,7 +32,4 @@
 ! $Id$
 !
-! 1318 2014-03-17 13:35:16Z raasch
-! module interfaces removed
-!
 ! 1092 2013-02-02 11:24:22Z raasch
 ! unused variables removed
@@ -37,24 +40,4 @@
 ! 841 2012-02-28 12:29:49Z maronga
 ! Excluded routine from compilation of namelist_file_check
-!
-! 707 2011-03-29 11:39:40Z raasch
-! bc_lr/ns replaced by bc_lr/ns_cyc
-! 
-! 702 2011-03-24 19:33:15Z suehring
-! Bugfix in declaration of ar in exchange_horiz_2d_int and number of MPI-blocks
-! in MPI_SENDRECV().
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! Dynamic exchange of ghost points with nbgp, which depends on the advection
-! scheme. Exchange between left and right PEs is now done with MPI-vectors.
-!
-! 73 2007-03-20 08:33:14Z raasch
-! Neumann boundary conditions at inflow/outflow in case of non-cyclic boundary
-! conditions
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.9  2006/05/12 19:15:52  letzel
-! MPI_REAL replaced by MPI_INTEGER in exchange_horiz_2d_int
 !
 ! Revision 1.1  1998/01/23 09:58:21  raasch
@@ -68,7 +51,16 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE cpulog
-    USE indices
+    USE control_parameters,                                                    &
+        ONLY :  inflow_l, inflow_n, inflow_r, inflow_s, outflow_l, outflow_n,  &
+                outflow_r, outflow_s
+                
+    USE cpulog,                                                                &
+        ONLY :  cpu_log, log_point_s
+        
+    USE indices,                                                               &
+        ONLY :  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg
+        
+    USE kinds
+    
     USE pegrid
 
@@ -76,6 +68,8 @@
 
 
-    REAL ::  ar(nysg:nyng,nxlg:nxrg)
-    INTEGER :: i
+    INTEGER(iwp) :: i  !:
+    
+    REAL(wp) ::  ar(nysg:nyng,nxlg:nxrg)  !:
+    
 
 #if ! defined( __check )
@@ -188,12 +182,20 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE cpulog
-    USE indices
+    USE control_parameters,                                                    &
+        ONLY:  bc_lr_cyc, bc_ns_cyc
+        
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+        
+    USE indices,                                                               &
+        ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg
+        
+    USE kinds
+    
     USE pegrid
 
     IMPLICIT NONE
 
-    INTEGER ::  ar(nysg:nyng,nxlg:nxrg)
+    INTEGER(iwp) ::  ar(nysg:nyng,nxlg:nxrg)  !:
 
 #if ! defined( __check )
Index: /palm/trunk/SOURCE/fft_xy.f90
===================================================================
--- /palm/trunk/SOURCE/fft_xy.f90	(revision 1319)
+++ /palm/trunk/SOURCE/fft_xy.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements, 
+! kinds are defined in new module kinds, 
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -65,24 +71,4 @@
 ! 1036 2012-10-22 13:43:42Z raasch
 ! code put under GPL (PALM 3.9)
-!
-! 274 2009-03-26 15:11:21Z heinze
-! Output of messages replaced by message handling routine.
-!
-! Feb. 2007
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.4  2006/03/28 12:27:09  raasch
-! Stop when system-specific fft is selected on NEC. For unknown reasons this
-! causes a program abort during first allocation in init_grid.
-!
-! Revision 1.2  2004/04/30 11:44:27  raasch
-! Module renamed from fft_for_1d_decomp to fft_xy, 1d-routines renamed to
-! fft_x and fft_y,
-! function FFT replaced by subroutine FFTN due to problems with 64-bit
-! mode on ibm,
-! shape of array cwork is explicitly stored in ishape/jshape and handled
-! to routine FFTN instead of shape-function (due to compiler error on
-! decalpha),
-! non vectorized FFT for nec included
 !
 ! Revision 1.1  2002/06/11 13:00:49  raasch
@@ -96,6 +82,10 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE indices
+    USE control_parameters,                                                    &
+        ONLY:  fft_method, message_string
+        
+    USE indices,                                                               &
+        ONLY:  nx, ny, nz
+        
 #if defined( __cuda_fft )
     USE ISO_C_BINDING
@@ -103,8 +93,14 @@
     USE, INTRINSIC ::  ISO_C_BINDING
 #endif
-    USE precision_kind
-    USE singleton
+
+    USE kinds
+    
+    USE singleton,                                                             &
+        ONLY: fftn
+    
     USE temperton_fft
-    USE transpose_indices
+    
+    USE transpose_indices,                                                     &
+        ONLY:  nyn_x, nys_x, nzb_x, nzb_y, nzt_x, nzt_y
 
     IMPLICIT NONE
@@ -113,31 +109,62 @@
     PUBLIC fft_x, fft_x_1d, fft_y, fft_y_1d, fft_init, fft_x_m, fft_y_m
 
-    INTEGER, DIMENSION(:), ALLOCATABLE, SAVE ::  ifax_x, ifax_y
-
-    LOGICAL, SAVE                            ::  init_fft = .FALSE.
-
-    REAL, SAVE ::  dnx, dny, sqr_dnx, sqr_dny
-    REAL, DIMENSION(:), ALLOCATABLE, SAVE    ::  trigs_x, trigs_y
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE, SAVE ::  ifax_x  !:
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE, SAVE ::  ifax_y  !:
+
+    LOGICAL, SAVE ::  init_fft = .FALSE.  !:
+
+    REAL(wp), SAVE ::  dnx      !:
+    REAL(wp), SAVE ::  dny      !:
+    REAL(wp), SAVE ::  sqr_dnx  !:
+    REAL(wp), SAVE ::  sqr_dny  !:
+    
+    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  trigs_x  !: 
+    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  trigs_y  !:
 
 #if defined( __ibm )
-    INTEGER, PARAMETER ::  nau1 = 20000, nau2 = 22000
+    INTEGER(iwp), PARAMETER ::  nau1 = 20000  !: 
+    INTEGER(iwp), PARAMETER ::  nau2 = 22000  !:
 !
 !-- The following working arrays contain tables and have to be "save" and
 !-- shared in OpenMP sense
-    REAL, DIMENSION(nau1), SAVE ::  aux1, auy1, aux3, auy3
+    REAL(wp), DIMENSION(nau1), SAVE ::  aux1  !: 
+    REAL(wp), DIMENSION(nau1), SAVE ::  auy1  !:
+    REAL(wp), DIMENSION(nau1), SAVE ::  aux3  !: 
+    REAL(wp), DIMENSION(nau1), SAVE ::  auy3  !:
+    
 #elif defined( __nec )
-    INTEGER, SAVE ::  nz1
-    REAL, DIMENSION(:), ALLOCATABLE, SAVE ::  trig_xb, trig_xf, trig_yb, &
-                                              trig_yf
+    INTEGER(iwp), SAVE ::  nz1  !:
+    
+    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  trig_xb  !:
+    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  trig_xf  !: 
+    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  trig_yb  !:
+    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  trig_yf  !:
+    
 #elif defined( __cuda_fft )
-    INTEGER(C_INT), SAVE ::  plan_xf, plan_xi, plan_yf, plan_yi
-    INTEGER, SAVE        ::  total_points_x_transpo, total_points_y_transpo
+    INTEGER(C_INT), SAVE ::  plan_xf  !:
+    INTEGER(C_INT), SAVE ::  plan_xi  !:
+    INTEGER(C_INT), SAVE ::  plan_yf  !:
+    INTEGER(C_INT), SAVE ::  plan_yi  !:
+    
+    INTEGER(iwp), SAVE   ::  total_points_x_transpo  !:
+    INTEGER(iwp), SAVE   ::  total_points_y_transpo  !:
 #endif
 
 #if defined( __fftw )
     INCLUDE  'fftw3.f03'
-    INTEGER(KIND=C_INT) ::  nx_c, ny_c
-    COMPLEX(KIND=C_DOUBLE_COMPLEX), DIMENSION(:), ALLOCATABLE, SAVE ::  x_out, y_out
-    REAL(KIND=C_DOUBLE), DIMENSION(:), ALLOCATABLE, SAVE            ::  x_in, y_in
+    INTEGER(KIND=C_INT) ::  nx_c  !:
+    INTEGER(KIND=C_INT) ::  ny_c  !:
+    
+    COMPLEX(KIND=C_DOUBLE_COMPLEX), DIMENSION(:), ALLOCATABLE, SAVE ::         &
+       x_out  !:
+    COMPLEX(KIND=C_DOUBLE_COMPLEX), DIMENSION(:), ALLOCATABLE, SAVE ::         &
+       y_out  !:
+    
+    REAL(KIND=C_DOUBLE), DIMENSION(:), ALLOCATABLE, SAVE ::                    &
+       x_in   !:
+    REAL(KIND=C_DOUBLE), DIMENSION(:), ALLOCATABLE, SAVE ::                    &
+       y_in   !:
+    
+    
     TYPE(C_PTR), SAVE ::  plan_xf, plan_xi, plan_yf, plan_yi
 #endif
@@ -186,12 +213,15 @@
 !--    in OpenMP sense
 #if defined( __ibm )
-       REAL, DIMENSION(0:nx+2) :: workx
-       REAL, DIMENSION(0:ny+2) :: worky
-       REAL, DIMENSION(nau2)   :: aux2, auy2, aux4, auy4
+       REAL(wp), DIMENSION(0:nx+2) ::  workx  !:
+       REAL(wp), DIMENSION(0:ny+2) ::  worky  !:
+       REAL(wp), DIMENSION(nau2)   ::  aux2   !: 
+       REAL(wp), DIMENSION(nau2)   ::  auy2   !: 
+       REAL(wp), DIMENSION(nau2)   ::  aux4   !: 
+       REAL(wp), DIMENSION(nau2)   ::  auy4   !:
 #elif defined( __nec )
-       REAL, DIMENSION(0:nx+3,nz+1)   ::  work_x
-       REAL, DIMENSION(0:ny+3,nz+1)   ::  work_y
-       REAL, DIMENSION(6*(nx+3),nz+1) ::  workx
-       REAL, DIMENSION(6*(ny+3),nz+1) ::  worky
+       REAL(wp), DIMENSION(0:nx+3,nz+1)   ::  work_x  !:
+       REAL(wp), DIMENSION(0:ny+3,nz+1)   ::  work_y  !:
+       REAL(wp), DIMENSION(6*(nx+3),nz+1) ::  workx   !:
+       REAL(wp), DIMENSION(6*(ny+3),nz+1) ::  worky   !:
 #endif 
 
@@ -228,5 +258,5 @@
           CALL message( 'fft_init', 'PA0187', 1, 2, 0, 6, 0 )
 
-          ALLOCATE( trig_xb(2*(nx+1)), trig_xf(2*(nx+1)), &
+          ALLOCATE( trig_xb(2*(nx+1)), trig_xf(2*(nx+1)),                      &
                     trig_yb(2*(ny+1)), trig_yf(2*(ny+1)) )
 
@@ -240,7 +270,7 @@
           CALL DZFFT( 0, nx+1, sqr_dnx, work_x, work_x, trig_xf, workx, 0 )
           CALL ZDFFT( 0, nx+1, sqr_dnx, work_x, work_x, trig_xb, workx, 0 )
-          CALL DZFFTM( 0, nx+1, nz1, sqr_dnx, work_x, nx+4, work_x, nx+4, &
+          CALL DZFFTM( 0, nx+1, nz1, sqr_dnx, work_x, nx+4, work_x, nx+4,      &
                        trig_xf, workx, 0 )
-          CALL ZDFFTM( 0, nx+1, nz1, sqr_dnx, work_x, nx+4, work_x, nx+4, &
+          CALL ZDFFTM( 0, nx+1, nz1, sqr_dnx, work_x, nx+4, work_x, nx+4,      &
                        trig_xb, workx, 0 )
 !
@@ -248,7 +278,7 @@
           CALL DZFFT( 0, ny+1, sqr_dny, work_y, work_y, trig_yf, worky, 0 )
           CALL ZDFFT( 0, ny+1, sqr_dny, work_y, work_y, trig_yb, worky, 0 )
-          CALL DZFFTM( 0, ny+1, nz1, sqr_dny, work_y, ny+4, work_y, ny+4, &
+          CALL DZFFTM( 0, ny+1, nz1, sqr_dny, work_y, ny+4, work_y, ny+4,      &
                        trig_yf, worky, 0 )
-          CALL ZDFFTM( 0, ny+1, nz1, sqr_dny, work_y, ny+4, work_y, ny+4, &
+          CALL ZDFFTM( 0, ny+1, nz1, sqr_dny, work_y, ny+4, work_y, ny+4,      &
                        trig_yb, worky, 0 )
 #elif defined( __cuda_fft )
@@ -278,5 +308,5 @@
           nx_c = nx+1
           ny_c = ny+1
-          ALLOCATE( x_in(0:nx+2), y_in(0:ny+2), x_out(0:(nx+1)/2), &
+          ALLOCATE( x_in(0:nx+2), y_in(0:ny+2), x_out(0:(nx+1)/2),             &
                     y_out(0:(ny+1)/2) )
           plan_xf = FFTW_PLAN_DFT_R2C_1D( nx_c, x_in, x_out, FFTW_ESTIMATE )
@@ -322,22 +352,33 @@
        IMPLICIT NONE
 
-       CHARACTER (LEN=*) ::  direction
-       INTEGER ::  i, ishape(1), j, k
-
-       LOGICAL ::  forward_fft
-
-       REAL, DIMENSION(0:nx+2)   ::  work
-       REAL, DIMENSION(nx+2)     ::  work1
-       COMPLEX, DIMENSION(:), ALLOCATABLE ::  cwork
+       CHARACTER (LEN=*) ::  direction  !:
+       
+       COMPLEX(wp), DIMENSION(:), ALLOCATABLE ::  cwork  !:
+
+       INTEGER(iwp) ::  i          !: 
+       INTEGER(iwp) ::  ishape(1)  !:
+       INTEGER(iwp) ::  j          !:
+       INTEGER(iwp) ::  k          !:
+
+       LOGICAL ::  forward_fft !:
+       
+       REAL(wp), DIMENSION(0:nx+2) ::  work   !:
+       REAL(wp), DIMENSION(nx+2)   ::  work1  !:
+       
 #if defined( __ibm )
-       REAL, DIMENSION(nau2)     ::  aux2, aux4
+       REAL(wp), DIMENSION(nau2) ::  aux2  !: 
+       REAL(wp), DIMENSION(nau2) ::  aux4  !:
 #elif defined( __nec )
-       REAL, DIMENSION(6*(nx+1)) ::  work2
+       REAL(wp), DIMENSION(6*(nx+1)) ::  work2  !:
 #elif defined( __cuda_fft )
-       COMPLEX(dpk), DIMENSION(0:(nx+1)/2,nys_x:nyn_x,nzb_x:nzt_x) ::  ar_tmp
+       COMPLEX(dpk), DIMENSION(0:(nx+1)/2,nys_x:nyn_x,nzb_x:nzt_x) ::          &
+          ar_tmp  !:
        !$acc declare create( ar_tmp )
 #endif
-       REAL, DIMENSION(0:nx,nys_x:nyn_x), OPTIONAL   ::  ar_2d
-       REAL, DIMENSION(0:nx,nys_x:nyn_x,nzb_x:nzt_x) ::  ar
+
+       REAL(wp), DIMENSION(0:nx,nys_x:nyn_x), OPTIONAL   ::                    &
+          ar_2d   !:
+       REAL(wp), DIMENSION(0:nx,nys_x:nyn_x,nzb_x:nzt_x) ::                    &
+          ar      !:
 
        IF ( direction == 'forward' )  THEN
@@ -540,6 +581,6 @@
                 DO  j = nys_x, nyn_x
 
-                   CALL DRCFT( 0, ar, 1, work, 1, nx+1, 1, 1, sqr_dnx, aux1, nau1, &
-                               aux2, nau2 )
+                   CALL DRCFT( 0, ar, 1, work, 1, nx+1, 1, 1, sqr_dnx, aux1,   &
+                               nau1, aux2, nau2 )
 
                    DO  i = 0, (nx+1)/2
@@ -570,6 +611,6 @@
                    work(nx+2) = 0.0
 
-                   CALL DCRFT( 0, work, 1, work, 1, nx+1, 1, -1, sqr_dnx, aux3, nau1, &
-                               aux4, nau2 )
+                   CALL DCRFT( 0, work, 1, work, 1, nx+1, 1, -1, sqr_dnx,      & 
+                               aux3, nau1, aux4, nau2 )
 
                    DO  i = 0, nx
@@ -709,17 +750,22 @@
        IMPLICIT NONE
 
-       CHARACTER (LEN=*) ::  direction
-       INTEGER ::  i, ishape(1)
-
-       LOGICAL ::  forward_fft
-
-       REAL, DIMENSION(0:nx)     ::  ar
-       REAL, DIMENSION(0:nx+2)   ::  work
-       REAL, DIMENSION(nx+2)     ::  work1
-       COMPLEX, DIMENSION(:), ALLOCATABLE ::  cwork
+       CHARACTER (LEN=*) ::  direction  !:
+       
+       INTEGER(iwp) ::  i               !:
+       INTEGER(iwp) ::  ishape(1)       !:
+
+       LOGICAL ::  forward_fft          !:
+
+       REAL(wp), DIMENSION(0:nx)   ::  ar     !:
+       REAL(wp), DIMENSION(0:nx+2) ::  work   !:
+       REAL(wp), DIMENSION(nx+2)   ::  work1  !:
+       
+       COMPLEX(wp), DIMENSION(:), ALLOCATABLE ::  cwork  !:
+       
 #if defined( __ibm )
-       REAL, DIMENSION(nau2)     ::  aux2, aux4
+       REAL(wp), DIMENSION(nau2) ::  aux2       !:
+       REAL(wp), DIMENSION(nau2) ::  aux4       !:
 #elif defined( __nec )
-       REAL, DIMENSION(6*(nx+1)) ::  work2
+       REAL(wp), DIMENSION(6*(nx+1)) ::  work2  !:
 #endif
 
@@ -838,5 +884,5 @@
           IF ( forward_fft )  THEN
 
-             CALL DRCFT( 0, ar, 1, work, 1, nx+1, 1, 1, sqr_dnx, aux1, nau1, &
+             CALL DRCFT( 0, ar, 1, work, 1, nx+1, 1, 1, sqr_dnx, aux1, nau1,   &
                          aux2, nau2 )
 
@@ -945,23 +991,37 @@
        IMPLICIT NONE
 
-       CHARACTER (LEN=*) ::  direction
-       INTEGER ::  i, j, jshape(1), k
-       INTEGER ::  nxl_y_bound, nxl_y_l, nxr_y_bound, nxr_y_l
-
-       LOGICAL ::  forward_fft
-
-       REAL, DIMENSION(0:ny+2)   ::  work
-       REAL, DIMENSION(ny+2)     ::  work1
-       COMPLEX, DIMENSION(:), ALLOCATABLE ::  cwork
+       CHARACTER (LEN=*) ::  direction  !:
+       
+       INTEGER(iwp) ::  i            !:
+       INTEGER(iwp) ::  j            !: 
+       INTEGER(iwp) ::  jshape(1)    !:
+       INTEGER(iwp) ::  k            !:
+       INTEGER(iwp) ::  nxl_y_bound  !:
+       INTEGER(iwp) ::  nxl_y_l      !:
+       INTEGER(iwp) ::  nxr_y_bound  !:
+       INTEGER(iwp) ::  nxr_y_l      !:
+
+       LOGICAL ::  forward_fft  !:
+
+       REAL(wp), DIMENSION(0:ny+2) ::  work   !:
+       REAL(wp), DIMENSION(ny+2)   ::  work1  !:
+       
+       COMPLEX(wp), DIMENSION(:), ALLOCATABLE ::  cwork  !:
+       
 #if defined( __ibm )
-       REAL, DIMENSION(nau2)     ::  auy2, auy4
+       REAL(wp), DIMENSION(nau2) ::  auy2  !:
+       REAL(wp), DIMENSION(nau2) ::  auy4  !:
 #elif defined( __nec )
-       REAL, DIMENSION(6*(ny+1)) ::  work2
+       REAL(wp), DIMENSION(6*(ny+1)) ::  work2  !:
 #elif defined( __cuda_fft )
-       COMPLEX(dpk), DIMENSION(0:(ny+1)/2,nxl_y:nxr_y,nzb_y:nzt_y) ::  ar_tmp
+       COMPLEX(dpk), DIMENSION(0:(ny+1)/2,nxl_y:nxr_y,nzb_y:nzt_y) ::          &
+          ar_tmp  !:
        !$acc declare create( ar_tmp )
 #endif
-       REAL, DIMENSION(0:ny,nxl_y_l:nxr_y_l,nzb_y:nzt_y) ::  ar
-       REAL, DIMENSION(0:ny,nxl_y_bound:nxr_y_bound,nzb_y:nzt_y) ::  ar_tr
+
+       REAL(wp), DIMENSION(0:ny,nxl_y_l:nxr_y_l,nzb_y:nzt_y)         ::        &
+          ar     !:
+       REAL(wp), DIMENSION(0:ny,nxl_y_bound:nxr_y_bound,nzb_y:nzt_y) ::        &
+          ar_tr  !:
 
        IF ( direction == 'forward' )  THEN
@@ -1140,6 +1200,6 @@
                 DO  i = nxl_y_l, nxr_y_l
 
-                   CALL DRCFT( 0, ar, 1, work, 1, ny+1, 1, 1, sqr_dny, auy1, nau1, &
-                               auy2, nau2 )
+                   CALL DRCFT( 0, ar, 1, work, 1, ny+1, 1, 1, sqr_dny, auy1,   & 
+                               nau1, auy2, nau2 )
 
                    DO  j = 0, (ny+1)/2
@@ -1170,6 +1230,6 @@
                    work(ny+2) = 0.0
 
-                   CALL DCRFT( 0, work, 1, work, 1, ny+1, 1, -1, sqr_dny, auy3, nau1, &
-                               auy4, nau2 )
+                   CALL DCRFT( 0, work, 1, work, 1, ny+1, 1, -1, sqr_dny,      &
+                               auy3, nau1, auy4, nau2 )
 
                    DO  j = 0, ny
@@ -1307,16 +1367,21 @@
 
        CHARACTER (LEN=*) ::  direction
-       INTEGER ::  j, jshape(1)
-
-       LOGICAL ::  forward_fft
-
-       REAL, DIMENSION(0:ny)     ::  ar
-       REAL, DIMENSION(0:ny+2)   ::  work
-       REAL, DIMENSION(ny+2)     ::  work1
-       COMPLEX, DIMENSION(:), ALLOCATABLE ::  cwork
+       
+       INTEGER(iwp) ::  j          !:
+       INTEGER(iwp) ::  jshape(1)  !:
+
+       LOGICAL ::  forward_fft  !:
+
+       REAL(wp), DIMENSION(0:ny)    ::  ar     !:
+       REAL(wp), DIMENSION(0:ny+2)  ::  work   !:
+       REAL(wp), DIMENSION(ny+2)    ::  work1  !:
+       
+       COMPLEX(wp), DIMENSION(:), ALLOCATABLE ::  cwork  !:
+       
 #if defined( __ibm )
-       REAL, DIMENSION(nau2)     ::  auy2, auy4
+       REAL(wp), DIMENSION(nau2) ::  auy2  !:
+       REAL(wp), DIMENSION(nau2) ::  auy4  !:
 #elif defined( __nec )
-       REAL, DIMENSION(6*(ny+1)) ::  work2
+       REAL(wp), DIMENSION(6*(ny+1)) ::  work2  !:
 #endif
 
@@ -1437,5 +1502,5 @@
           IF ( forward_fft )  THEN
 
-             CALL DRCFT( 0, ar, 1, work, 1, ny+1, 1, 1, sqr_dny, auy1, nau1, &
+             CALL DRCFT( 0, ar, 1, work, 1, ny+1, 1, 1, sqr_dny, auy1, nau1,   &
                          auy2, nau2 )
 
@@ -1458,6 +1523,6 @@
              work(ny+2) = 0.0
 
-             CALL DCRFT( 0, work, 1, work, 1, ny+1, 1, -1, sqr_dny, auy3, nau1, &
-                         auy4, nau2 )
+             CALL DCRFT( 0, work, 1, work, 1, ny+1, 1, -1, sqr_dny, auy3,      &
+                         nau1, auy4, nau2 )
 
              DO  j = 0, ny
@@ -1527,13 +1592,18 @@
        IMPLICIT NONE
 
-       CHARACTER (LEN=*)              ::  direction
-       INTEGER                        ::  i, k, siza
-
-       REAL, DIMENSION(0:nx,nz)       ::  ar
-       REAL, DIMENSION(0:nx+3,nz+1)   ::  ai
-       REAL, DIMENSION(6*(nx+4),nz+1) ::  work1
+       CHARACTER (LEN=*) ::  direction  !:
+       
+       INTEGER(iwp) ::  i     !:
+       INTEGER(iwp) ::  k     !:
+       INTEGER(iwp) ::  siza  !:
+
+       REAL(wp), DIMENSION(0:nx,nz)       ::  ar     !:
+       REAL(wp), DIMENSION(0:nx+3,nz+1)   ::  ai     !:
+       REAL(wp), DIMENSION(6*(nx+4),nz+1) ::  work1  !:
+       
 #if defined( __nec )
-       INTEGER                             ::  sizw
-       COMPLEX, DIMENSION((nx+4)/2+1,nz+1) ::  work
+       INTEGER(iwp) ::  sizw  !:
+       
+       COMPLEX(wp), DIMENSION((nx+4)/2+1,nz+1) ::  work  !:
 #endif
 
@@ -1588,5 +1658,5 @@
 !--          Tables are initialized once more. This call should not be
 !--          necessary, but otherwise program aborts in asymmetric case
-             CALL DZFFTM( 0, nx+1, nz1, sqr_dnx, work, nx+4, work, nx+4, &
+             CALL DZFFTM( 0, nx+1, nz1, sqr_dnx, work, nx+4, work, nx+4,       &
                           trig_xf, work1, 0 )
 
@@ -1596,5 +1666,5 @@
              ENDIF
 
-             CALL DZFFTM( 1, nx+1, nz1, sqr_dnx, ai, siza, work, sizw, &
+             CALL DZFFTM( 1, nx+1, nz1, sqr_dnx, ai, siza, work, sizw,         &
                           trig_xf, work1, 0 )
 
@@ -1613,5 +1683,5 @@
 !--          Tables are initialized once more. This call should not be
 !--          necessary, but otherwise program aborts in asymmetric case
-             CALL ZDFFTM( 0, nx+1, nz1, sqr_dnx, work, nx+4, work, nx+4, &
+             CALL ZDFFTM( 0, nx+1, nz1, sqr_dnx, work, nx+4, work, nx+4,       &
                           trig_xb, work1, 0 )
 
@@ -1664,13 +1734,19 @@
        IMPLICIT NONE
 
-       CHARACTER (LEN=*)              ::  direction
-       INTEGER                        ::  j, k, ny1, siza
-
-       REAL, DIMENSION(0:ny1,nz)      ::  ar
-       REAL, DIMENSION(0:ny+3,nz+1)   ::  ai
-       REAL, DIMENSION(6*(ny+4),nz+1) ::  work1
+       CHARACTER (LEN=*) ::  direction  !:
+       
+       INTEGER(iwp) ::  j     !: 
+       INTEGER(iwp) ::  k     !:
+       INTEGER(iwp) ::  ny1   !:
+       INTEGER(iwp) ::  siza  !:
+
+       REAL(wp), DIMENSION(0:ny1,nz)      ::  ar     !:
+       REAL(wp), DIMENSION(0:ny+3,nz+1)   ::  ai     !:
+       REAL(wp), DIMENSION(6*(ny+4),nz+1) ::  work1  !:
+       
 #if defined( __nec )
-       INTEGER                             ::  sizw
-       COMPLEX, DIMENSION((ny+4)/2+1,nz+1) ::  work
+       INTEGER(iwp) ::  sizw  !:
+       
+       COMPLEX(wp), DIMENSION((ny+4)/2+1,nz+1) ::  work !:
 #endif
 
